/****************************************************************************
**
** Copyright (C) 1992-2006 Trolltech ASA. All rights reserved.
**
** This file is part of the example classes of the Qt Toolkit.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** sales department at sales@trolltech.com.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "sim300_dbus.h"
#include <QtCore/QCoreApplication>

#include "sim300_dbus_adaptor.h"
#include "sim300_dbus_interface.h"

#include "sim300.h"
#include "sim300_dbus_init.h"

MainClass::MainClass()
{
    // add our D-Bus interface and connect to D-Bus
    new Sim300Adaptor(this);
    QDBusConnection connection = QDBusConnection::sessionBus();
    connection.registerObject("/sim300", this);
    connection.registerService("com.i_zum.jukebox.sim300");
    //QDBusConnection::sessionBus().registerObject("/", this);

    com::i_zum::sim300 *iface;
    iface = new com::i_zum::sim300(QString(), QString(), QDBusConnection::sessionBus(), this);
    //connect(iface, SIGNAL(message(QString,QString)), this, SLOT(messageSlot(QString,QString)));
    QDBusConnection::sessionBus().connect(QString(), QString(), "com.i_zum.jukebox.sim300", "counters", this, SLOT(countersSlot(QByteArray)));
    //connect(iface, SIGNAL(action(QString,QString)), this, SLOT(actionSlot(QString,QString)));
}

MainClass::~MainClass()
{
}

void MainClass::countersSlot(const QByteArray &byte_arr)
{
    qWarning("Counters received: %u\n", byte_arr.size());
    //upload_data((unsigned char*)byte_arr.data(), byte_arr.size(), true, "www.i-zum.com", 80);
    qWarning("Counters transmited.\n");
}

QString MainClass::get_csq(uchar &rssi, uchar &ber)
{
    // handle method call com.i_zum.jukebox.sim300.get_csq
    //return static_cast<YourObjectType *>(parent())->get_csq(rssi, ber);
    qWarning("try to get rssi && ber.\n");
    qWarning("rssi && ber received.\n");
    return QString();
}

QString MainClass::get_money_atd(QString &money)
{
    // handle method call com.i_zum.jukebox.sim300.get_money_atd
    //return static_cast<YourObjectType *>(parent())->get_money_atd(money);
    qWarning("Try to get money via ATD.\n");
    qWarning("Money via ATD recived.\n");
    return QString();
}

QString MainClass::get_money_cusd(QString &money)
{
    // handle method call com.i_zum.jukebox.sim300.get_money_cusd
    //return static_cast<YourObjectType *>(parent())->get_money_cusd(money);
    qWarning("try to get money via CUSD.\n");
    qWarning("Money via CUSD received.\n");
    return QString();
}

NicknameDialog::NicknameDialog(QObject *parent)
{
}

NicknameDialog::~NicknameDialog()
{
}

int sim300_main(int argc, char **argv)
{
    QCoreApplication app(argc, argv);

    if (!QDBusConnection::sessionBus().isConnected()) {
        qWarning("Cannot connect to the D-BUS session bus.\n"
                 "Please check your system settings and try again.\n");
        return 1;
    }

    MainClass sim300;
    return app.exec();
}

int sim300_init(int argc, char **argv)
{
    int pid=fork();
    if(!pid)
        exit(sim300_main(argc, argv));
    else
        return pid;
}

int main(int argc, char **argv)
{
    return sim300_main(argc, argv);
}
